#include "triangle.h"

void Triangle::Rasterize(FrameBuffer *fb) {

  AABB bb;
  bb.AddPoint(verts[0]);
  bb.AddPoint(verts[1]);
  bb.AddPoint(verts[2]);

  if (!fb->ClipBB(bb))
    return;

  int lefti = (int) (bb[0][0]+0.5f);
  int righti = (int) (bb[1][0]-0.5f);
  int topi = (int) (bb[0][1]+0.5f);
  int bottomi = (int) (bb[1][1]-0.5f);

  for (int v = topi; v <= bottomi; v++) {
    for (int u = lefti; u <= righti; u++) {
      V3 pixv(.5f+(float)u, .5f+(float)v, 0.0f);
      unsigned int colui = color.GetColor();
      fb->Set(u, v, colui);
    }
  }

}
